// Pro

#include <stdio.h>
#include <math.h>
#include <graphics.h>
#include <stdlib.h>
#define blue 1
#define white 15
#define red 4

int xsize, ysize;
int bound;

main()
{
	int i1, i2, index, junk, numpts;
	int T_x;
	int T_y;
	int T_scale;
	int star_x;
	int star_y;
	int star_scale;
	int mx,my;
	int map[450][2];
	int star[11][2];
	int dout[25][2];
	int T_cent[2];
	int center[2];
	float x,y;
	FILE *mapfile;

	initialize();

	// Set Star Structure with General Star at 0,0;
	star[0][0] = 0;
	star[0][1] = 4;
	star[1][0] = 3;
	star[1][1] = 4;
	star[2][0] = 4;
	star[2][1] = 0;
	star[3][0] = 5;
	star[3][1] = 4;
	star[4][0] = 8;
	star[4][1] = 4;
	star[5][0] = 6;
	star[5][1] = 7;
	star[6][0] = 7;
	star[6][1] = 11;
	star[7][0] = 4;
	star[7][1] = 9;
	star[8][0] = 1;
	star[8][1] = 11;
	star[9][0] = 2;
	star[9][1] = 7;
	star[10][0] = star[0][0];
	star[10][1] = star[0][1];
	center[0] = 4;
	center[1] = 6;

	// Set Double T Structure with general T
	dout[0][0] =0;
	dout[0][1] =0;
	dout[1][0] =18;
	dout[1][1] =0;
	dout[2][0] =18;
	dout[2][1] =5;
	dout[3][0] =14;
	dout[3][1] =5;
	dout[4][0] =14;
	dout[4][1] =4;
	dout[5][0] =11;
	dout[5][1] =4;
	dout[6][0] =11;
	dout[6][1] =7;
	dout[7][0] =15;
	dout[7][1] =7;
	dout[8][0] =15;
	dout[8][1] =10;
	dout[9][0] =11;
	dout[9][1] =10;
	dout[10][0]=11;
	dout[10][1]=17;
	dout[11][0]=13;
	dout[11][1]=17;
	dout[12][0]=13;
	dout[12][1]=20;
	dout[13][0]=5;
	dout[13][1]=20;
	dout[14][0]=5;
	dout[14][1]=17;
	dout[15][0]=7;
	dout[15][1]=17;
	dout[16][0]=7;
	dout[16][1]=10;
	dout[17][0]=3;
	dout[17][1]=10;
	dout[18][0]=3;
	dout[18][1]=7;
	dout[19][0]=7;
	dout[19][1]=7;
	dout[20][0]=7;
	dout[20][1]=4;
	dout[21][0]=4;
	dout[21][1]=4;
	dout[22][0]=4;
	dout[22][1]=5;
	dout[23][0]=0;
	dout[23][1]=5;
	dout[24][0]=dout[0][0];
	dout[24][1]=dout[0][1];
	T_cent[0]=9;
	T_cent[1]=9;
	setviewport(0,0,639,479,1);
	setcolor(12);
	index = 0;
	mx=0;
	my=0;

	mapfile = fopen("texas.map","r");
	while(fscanf(mapfile,"%f %f %d",&x,&y,&junk) !=EOF)
	{
		map[index][0] = x;
		map[index][1] = y;
		if (x > mx) mx = x;
		if (y > my) my = y;
		index++;
	}
	numpts = index;

	map[numpts][0] = map[0][0];
	map[numpts][1] = map[0][1];

	bound = xsize/4.5;
	for(index=0;index<=numpts;index++)
	{
		map[index][0] = ((float) map[index][0] / mx * (xsize-bound))*0.75;
		map[index][1] = ysize - (map[index][1] / (float) my * ysize) * 0.75;
		map[index][0] = map[index][0] + (xsize - bound)*0.1;
		map[index][1] = map[index][1] - ysize*0.15;
	}

	// Draw Texas Map in construction color (12)
	drawpoly(numpts, (int far *)map);

	// Separate into three parts
	// Draw Vertical Section Line
	moveto(238,0);
	lineto(238,439);
	// Fill blue
	setfillstyle(1,blue);
	floodfill(237,189, 12);
	// Draw Horizontal Section Line
	moveto(239,194);
	lineto(500,194);
	// Fill white
	setfillstyle(1,white);
	floodfill(241,188,12);
	//fill red
	setfillstyle(1,red);
	floodfill(241,195,12);
	// Draw Boarder white to remove construction lines
	setcolor(white);
	drawpoly(numpts,(int far *)map);

	// Fill black with green lines to remove construction lines
	setfillstyle(7,2);
	floodfill(0,0,white);
	// Remove white boarder from texas map
	setcolor(0);
	drawpoly(numpts,(int far *)map);

	// Draw and Fill Star on Map

	// Scale and Translate Star to a nicer location
	star_scale = 9;
	star_x =170;
	star_y =150;
	for (index=0;index<=11;index++)
	{
		star[index][0] = star_scale*star[index][0]+star_x;
		star[index][1] = star_scale*star[index][1]+star_y;
	}
	// This is the Center (For seed point)
	center[0] = center[0]*star_scale+star_x;
	center[1] = center[1]*star_scale+star_y;

	setcolor(0);
	setfillstyle(1,0);
	drawpoly(11,(int far *)star);
	floodfill(center[0],center[1],0);
	for (index=0;index<=11;index++)
	{
		star[index][0] = star[index][0]-10;  // Standard location 160
		star[index][1] = star[index][1]-10;  // Standard Location 140
	}
	// This is the Center (For seed point)
	center[0] = center[0]-10;
	center[1] = center[1]-10;

	setcolor(white);
	setfillstyle(1,white);
	drawpoly(11,(int far *)star);
	floodfill(center[0],center[1],white);

	// Scale Translate and draw Double T Symbol
	T_scale = 5;
	T_x =450;
	T_y =350;
	for (index=0;index<=25;index++)
	{
		dout[index][0] = T_scale*dout[index][0]+T_x;
		dout[index][1] = T_scale*dout[index][1]+T_y;
	}
	T_cent[0] = T_cent[0]*T_scale+T_x;
	T_cent[1] = T_cent[1]*T_scale+T_y;

  //	drawpoly(25,(int far *)dout);
	setfillstyle(8,8);
	fillpoly(25,(int far *)dout);
	for (index=0;index<=25;index++)
	{
		dout[index][0] = dout[index][0]-10;
		dout[index][1] = dout[index][1]-10;
	}
	T_cent[0] = T_cent[0]-10;
	T_cent[1] = T_cent[1]-10;

	setfillstyle(1,red);
	fillpoly(25,(int far *)dout);


	outtextxy(450,100,"Project 3");
	outtextxy(450,125,"Texas Region Filling");
	outtextxy(450,150,"Jeremy C. Witt");
	outtextxy(450,175,"462.35.8529");
	outtextxy(450,200,"CS-4395 : 3/5/96");
	outtextxy(450,225,"Texas Tech University");

	getche();
	closegraph();
}

initialize(void)
{
	int gdriver, gmode, gerror;

	gdriver = DETECT;
	detectgraph(&gdriver,&gmode);
	initgraph(&gdriver,&gmode,"");

	xsize = getmaxx();
	ysize = getmaxy();
}
