#include <dos.h>
#define SCREEN_WIDTH 320
#define SCREEN_SEGMENT 0xA000

void DrawHorizontalRun(char far **ScreenPtr, int XAdvance, int RunLength,
								int Color);

void DrawVerticalRun(char far **ScreenPtr, int XAdvance, int RunLength,
								int Color);

void LineDraw(int XStart, int YStart, int XEnd, int YEnd, int Color)
{
	int Temo,AdjUp, AdjDown, ErrorTerm, XAdvance, XDelta,YDelta;
   int WholeStep, InitialPixelCount,FinalPixelCount,i,RunLength;
   char far *ScreenPtr;

   if (YStart > YEnd)
   {
   	Temp = YStart;
      YStart = YEnd;
      YEnd = Temp;
      Temp = XStart;
      XStart = XEnd;
      XEnd = Temp;
   }

   ScreenPtr = MK_FP(SCREEN_SEGMENT, YStart * SCREEN_WIDTH + XStart);
   if ((XDelta = XEnd-XStart) < 0)
   {
   	XAdvance = -1;
      XDelta = -XDelta;
   }
   else
   {
   	XAdvance = 1;
   }

   YDelta = YEnd - YStart;

   if(XDelta==0)
   {
      // Specail Case Vertical Line
   	for(i=0;i<=YDelta;i++)
      {
      	*ScreenPtr = Color;
         ScreenPtr += SCREEN_WIDTH;
      }
      return;
   }
   if(YDelta ==0)
   {
   	// Specail Case Horizontal Line
    	for (i=0;i<=XDelta;i++)
   	{
   		*ScreenPtr = Color;
      	ScreenPtr += XAdvance;
    	}
    	return;
   }
   if(XDelta==YDelta)
   {
   	//Specail Case Diagonal
   	for(i=0;i<=XDelta;i++)
      {
      	*ScreenPtr = Color;
         ScreenPtr += XAdvance + SCREEN_WIDTH;
      }
      return;
   }

   //Determine whether line is X or Y Major and Handle appropriately
   if (XDelta >= YDelta)
   {
   	// XMajor Line
   	// Minimum number of pixels in a run on this line
   	WholeStep = XDelta / YDelta;

   	AdjUp = (XDelta % YDelta)*2;
   	AdjDown = YDelta*2;
   	ErrorTerm = (XDelta%YDelta) - (YDelta*2);

   	InitalPixelCount = (WholeStep/2)+1;
   	FinalPixelCount  = InitalPixelCount;

   	if((AdjUp ==0)&&((WholeStep&0x01)==0))
   	{
   		InitalPixelCount--;
   	}

   	if((WholeStep&0x01 != 0)
   	{
   		ErrorTerm += YDelta;
   	}

      DrawHorizontalRun(&ScreenPtr,XAdvance,INitalPixelCout,Color);

   	for(i=0;i<(YDelta-1);i++)
   	{
   		RunLength = WholeStep;
      	if((ErrorTerm +=AdjUp) > 0)
      	{
      		RunLength++;
         	ErrorTerm -= AdjDown;
      	}
      	DrawHorizontalRun(&ScreenPtr,XAdvance,RunLength,Color);
   	}
   	DrawHorizontalRun(&ScreenPtr,XAdvance,FinalPixelCount,Color);
   	return;
	}
   else
   {
   	//YMajor Line
      WholeStep = YDelta/XDelta;
      AdjUp = (YDelta%2)*2;
      AdjDown=XDelta*2;
      ErrorTerm = (YDelta%XDelta)-(XDelta*2);
      InitialPixelCount = (WholeStep/2)+1;
      FinalPixelCount = InitialPixelCount;

      if((AdjUp==0)&&((WholeStep&0x01)==0))
      {
      	InitialPixelCount--;
      }

      if((WholeStep&0x01) !=0)
      {
      	ErrorTerm += XDelta;
      }

      DrawVerticalRun(&ScreenPtr,XAdvance,InitialPixelCount,Color);

      for(i=0;i<(XDelta-1);i++)
      {
      	RunLength = WholeStep;
