#include <stdio.h>
#include <math.h>
#include <graphics.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>
#define blue 1
#define white 15
#define red 4
#define X_COMP 0
#define Y_COMP 1
#define Z_COMP 2
#define N_COMP 3


int xsize,ysize;
int bound;

typedef struct vector_type
{
 float p[4]; // a 3d point with normalizing vector
} vector, *vector_ptr;

typedef struct matrix_type
{
 float elem[4][4];
} matrix, *matrix_ptr;

/*typedef struct object_type
{
 vector_ptr Point[20];
} object, *object_ptr;*/

void Mat_Mul(vector_ptr,matrix_ptr);
void Create_TE(vector_ptr , matrix_ptr);
void initialize(void);
//void Define_Cube(object_ptr);



main()
{
	int map[450][2];
 //  int dout[25][2];
   int T_cent[2];
   int mx,my;
   float maxx,maxy,minx,miny;
   float d;
   float x,y;
   int junk;
   int index,numpts,cubepts;
   vector_ptr Evect;
   matrix_ptr TE;
//   object_ptr Cube; // a standard Cube (0,0,0) to (100,100,100)
   FILE *mapfile;
   initialize();
   minx=0.0;
   miny=0.0;
   minx=1000.0;
   miny=1000.0;
   Evect->p[X_COMP]=200.0;
   Evect->p[Y_COMP]=200.0;
   Evect->p[Z_COMP]=282.8;
   Evect->p[N_COMP]=1.0;
   cubepts =15;
 //  Define_Cube(Cube);
   	// Set Double T Structure with general T
 /*	dout[0][0] =0;
	dout[0][1] =0;
	dout[1][0] =18;
	dout[1][1] =0;
	dout[2][0] =18;
	dout[2][1] =5;
	dout[3][0] =14;
	dout[3][1] =5;
	dout[4][0] =14;
	dout[4][1] =4;
	dout[5][0] =11;
	dout[5][1] =4;
	dout[6][0] =11;
	dout[6][1] =7;
	dout[7][0] =15;
	dout[7][1] =7;
	dout[8][0] =15;
	dout[8][1] =10;
	dout[9][0] =11;
	dout[9][1] =10;
	dout[10][0]=11;
	dout[10][1]=17;
	dout[11][0]=13;
	dout[11][1]=17;
	dout[12][0]=13;
	dout[12][1]=20;
	dout[13][0]=5;
	dout[13][1]=20;
	dout[14][0]=5;
	dout[14][1]=17;
	dout[15][0]=7;
	dout[15][1]=17;
	dout[16][0]=7;
	dout[16][1]=10;
	dout[17][0]=3;
	dout[17][1]=10;
	dout[18][0]=3;
	dout[18][1]=7;
	dout[19][0]=7;
	dout[19][1]=7;
	dout[20][0]=7;
	dout[20][1]=4;
	dout[21][0]=4;
	dout[21][1]=4;
	dout[22][0]=4;
	dout[22][1]=5;
	dout[23][0]=0;
	dout[23][1]=5;
	dout[24][0]=dout[0][0];
	dout[24][1]=dout[0][1]; */
	T_cent[0]=9;
	T_cent[1]=9;
	setviewport(0,0,639,479,1);
	setcolor(12);
   index=0;
   mx=0;
   my=0;


   mapfile = fopen("texas.map","r");
	while(fscanf(mapfile,"%f %f %d",&x,&y,&junk) !=EOF)
	{
		map[index][0] = x;
		map[index][1] = y;
		if (x > mx) mx = x;
		if (y > my) my = y;
		index++;
	}
	numpts = index;

	map[numpts][0] = map[0][0];
	map[numpts][1] = map[0][1];
   bound = xsize/4.5;
	for(index=0;index<=numpts;index++)
	{
		map[index][0] = ((float) map[index][0] / mx * (xsize-bound))*0.75;
		map[index][1] = ysize - (map[index][1] / (float) my * ysize) * 0.75;
		map[index][0] = map[index][0] + (xsize - bound)*0.1;
		map[index][1] = map[index][1] - ysize*0.15;
      if (map[index][0] > maxx) maxx = map[index][0];
      if (map[index][1] > maxy) maxy = map[index][1];
      if (map[index][0] < minx) minx = map[index][0];
      if (map[index][1] < miny) miny = map[index][1];
	}

 //  setcolor(white);
   drawpoly(numpts, (int far *)map);

   getche();
	closegraph();

   printf("Maxx: %f Minx: %f\n",maxx,minx);
   printf("Maxy: %f Miny: %f\n",maxy,miny);
   printf("XSize: %f YSize: %f\n",maxx-minx,maxy-miny);
      Create_TE(Evect,TE);
   printf(" |%f  %f  %f  %f|\n", TE->elem[0][0],TE->elem[0][1],TE->elem[0][2],
          TE->elem[0][3]);
   printf(" |%f  %f  %f  %f|\n", TE->elem[1][0],TE->elem[1][1],TE->elem[1][2],
          TE->elem[1][3]);
   printf(" |%f  %f  %f  %f|\n", TE->elem[2][0],TE->elem[2][1],TE->elem[2][2],
          TE->elem[2][3]);
   printf(" |%f  %f  %f  %f|\n", TE->elem[3][0],TE->elem[3][1],TE->elem[3][2],
          TE->elem[3][3]);

} // End of Main



void initialize(void)
{
	int gdriver, gmode, gerror;

	gdriver = DETECT;
	detectgraph(&gdriver,&gmode);
	initgraph(&gdriver,&gmode,"");

	xsize = getmaxx();
	ysize = getmaxy();
}

void Mat_Mul(vector_ptr v,matrix_ptr m)
{
	float x_new, y_new, z_new;
   x_new = m->elem[0][0]*v->p[0]+m->elem[0][1]*v->p[1]+
           m->elem[0][2]*v->p[2]+m->elem[0][3]*v->p[3];
   y_new = m->elem[1][0]*v->p[0]+m->elem[1][1]*v->p[1]+
           m->elem[1][2]*v->p[2]+m->elem[1][3]*v->p[3];
   z_new = m->elem[2][0]*v->p[0]+m->elem[2][1]*v->p[1]+
           m->elem[2][2]*v->p[2]+m->elem[2][3]*v->p[3];
   v->p[X_COMP] = x_new;
   v->p[Y_COMP] = y_new;
   v->p[Z_COMP] = z_new;
   v->p[N_COMP] = 1.0;
}

void Create_TE(vector_ptr E, matrix_ptr m)
{
   float x,y,z;
	float Theta,Phi,Rho;
   x = E->p[X_COMP];
   y = E->p[Y_COMP];
   z = E->p[Z_COMP];
   Rho = (float) sqrt((double)((x*x)+(y*y)+(z*z)));
   Theta = asin(y/(float)(sqrt((double)((x*x)+(y*y)))));
   Phi =   acos(z/Rho);
   m->elem[0][0] = -sin(Theta);
   m->elem[0][1] = cos(Theta);
   m->elem[0][2] = 0.0;
   m->elem[0][3] = 0.0;
   m->elem[1][0] = -cos(Phi)*cos(Theta);
   m->elem[1][1] = -cos(Phi)*sin(Theta);
   m->elem[1][2] = sin(Phi);
   m->elem[1][3] = 0.0;
   m->elem[2][0] = -sin(Phi)*cos(Theta);
   m->elem[2][1] = -sin(Phi)*sin(Theta);
   m->elem[2][2] = -cos(Phi);
   m->elem[2][3] = Rho;
   m->elem[3][0] = 0.0;
   m->elem[3][1] = 0.0;
   m->elem[3][2] = 0.0;
   m->elem[3][3] = 1.0;
}

/*void Define_Cube(object_ptr cube)
{
  cube->Point[0]->p[X_COMP] = 100.0;
  cube->Point[0]->p[Y_COMP] = 0.0;
  cube->Point[0]->p[Z_COMP] = 0.0;
  cube->Point[0]->p[N_COMP] = 1.0;
  cube->Point[1]->p[X_COMP] = 100.0;
  cube->Point[1]->p[Y_COMP] = 100.0;
  cube->Point[1]->p[Z_COMP] = 0.0;
  cube->Point[1]->p[N_COMP] = 1.0;
  cube->Point[2]->p[X_COMP] = 100.0;
  cube->Point[2]->p[Y_COMP] = 100.0;
  cube->Point[2]->p[Z_COMP] = 100.0;
  cube->Point[2]->p[N_COMP] = 1.0;
  cube->Point[3]->p[X_COMP] = 100.0;
  cube->Point[3]->p[Y_COMP] = 0.0;
  cube->Point[3]->p[Z_COMP] = 100.0;
  cube->Point[3]->p[N_COMP] = 1.0;
  cube->Point[4]->p[X_COMP] = 100.0;
  cube->Point[4]->p[Y_COMP] = 0.0;
  cube->Point[4]->p[Z_COMP] = 0.0;
  cube->Point[4]->p[N_COMP] = 1.0;
  cube->Point[5]->p[X_COMP] = 100.0;
  cube->Point[5]->p[Y_COMP] = 0.0;
  cube->Point[5]->p[Z_COMP] = 100.0;
  cube->Point[5]->p[N_COMP] = 1.0;
  cube->Point[6]->p[X_COMP] = 100.0;
  cube->Point[6]->p[Y_COMP] = 100.0;
  cube->Point[6]->p[Z_COMP] = 100.0;
  cube->Point[6]->p[N_COMP] = 1.0;
  cube->Point[7]->p[X_COMP] = 0.0;
  cube->Point[7]->p[Y_COMP] = 100.0;
  cube->Point[7]->p[Z_COMP] = 100.0;
  cube->Point[7]->p[N_COMP] = 1.0;
  cube->Point[8]->p[X_COMP] = 0.0;
  cube->Point[8]->p[Y_COMP] = 0.0;
  cube->Point[8]->p[Z_COMP] = 100.0;
  cube->Point[8]->p[N_COMP] = 1.0;
  cube->Point[9]->p[X_COMP] = 100.0;
  cube->Point[9]->p[Y_COMP] = 0.0;
  cube->Point[9]->p[Z_COMP] = 100.0;
  cube->Point[9]->p[N_COMP] = 1.0;
  cube->Point[10]->p[X_COMP] = 100.0;
  cube->Point[10]->p[Y_COMP] = 100.0;
  cube->Point[10]->p[Z_COMP] = 0.0;
  cube->Point[10]->p[N_COMP] = 1.0;
  cube->Point[11]->p[X_COMP] = 0.0;
  cube->Point[11]->p[Y_COMP] = 100.0;
  cube->Point[11]->p[Z_COMP] = 0.0;
  cube->Point[11]->p[N_COMP] = 1.0;
  cube->Point[12]->p[X_COMP] = 0.0;
  cube->Point[12]->p[Y_COMP] = 100.0;
  cube->Point[12]->p[Z_COMP] = 100.0;
  cube->Point[12]->p[N_COMP] = 1.0;
  cube->Point[13]->p[X_COMP] = 100.0;
  cube->Point[13]->p[Y_COMP] = 100.0;
  cube->Point[13]->p[Z_COMP] = 100.0;
  cube->Point[13]->p[N_COMP] = 1.0;
  cube->Point[14]->p[X_COMP] = 100.0;
  cube->Point[14]->p[Y_COMP] = 100.0;
  cube->Point[14]->p[Z_COMP] = 0.0;
  cube->Point[14]->p[N_COMP] = 1.0;
} */
