#include "C:\jlib\jlib.h"
#include "c:\jlib\jgfx.c"

void main(void)
{
	long index, redraw;
	RGB_color color;
	int frame_dir = 1;
	int ind2=47;
	pcx_picture cobalt, logos;

	sprite logo;

	Set_Mode(VGA256);

	PCX_Init((pcx_picture_ptr)&cobalt);
	PCX_Load("backdrop.pcx", (pcx_picture_ptr)&cobalt, 1);
	PCX_Show_Buffer((pcx_picture_ptr)&cobalt);

	double_buffer = cobalt.buffer;

//	PCX_Delete((pcx_picture_ptr)&cobalt);
	Blit_String(25,160,50, "UnderMidnight");

	PCX_Init((pcx_picture_ptr)&logos);
	PCX_Load("logos1.pcx",(pcx_picture_ptr)&logos,0);
	Sprite_Init((sprite_ptr)&logo, SPRITE_WIDTH, 100, 0, 7,0,3);

	PCX_Grap_Bitmap((pcx_picture_ptr)&logos, (sprite_ptr)&logo,0,0,0);
	PCX_Grap_Bitmap((pcx_picture_ptr)&logos, (sprite_ptr)&logo,1,1,0);
	PCX_Grap_Bitmap((pcx_picture_ptr)&logos, (sprite_ptr)&logo,2,2,0);
	PCX_Grap_Bitmap((pcx_picture_ptr)&logos, (sprite_ptr)&logo,3,3,0);
	PCX_Grap_Bitmap((pcx_picture_ptr)&logos, (sprite_ptr)&logo,4,4,0);
	PCX_Grap_Bitmap((pcx_picture_ptr)&logos, (sprite_ptr)&logo,5,4,0);
	PCX_Grap_Bitmap((pcx_picture_ptr)&logos, (sprite_ptr)&logo,6,3,0);
	PCX_Grap_Bitmap((pcx_picture_ptr)&logos, (sprite_ptr)&logo,7,2,0);
	PCX_Grap_Bitmap((pcx_picture_ptr)&logos, (sprite_ptr)&logo,8,1,0);
	PCX_Grap_Bitmap((pcx_picture_ptr)&logos, (sprite_ptr)&logo,9,0,0);

	PCX_Delete((pcx_picture_ptr)&logos);
	Behind_Sprite((sprite_ptr)&logo);
//	Draw_Sprite((sprite_ptr)&logo);
	logo.state=SPRITE_ALIVE;

	while(!kbhit())
	{
		redraw = 0;
		if(logo.state==SPRITE_ALIVE)
		{
			if(++logo.anim_clock > logo.anim_speed)
			{
				logo.anim_clock = 0;
				if(++logo.curr_frame>=logo.num_frames)
					logo.curr_frame = 0;
				redraw = 1;
				if (ind2 == 104)
					ind2 =47;
				Blit_String(25,160,ind2++, "UnderMidnight");
			}

			if(++logo.motion_clock > logo.motion_speed)
			{
				logo.motion_clock = 0;
				logo.x_old = logo.x;
				logo.y_old = logo.y;
				redraw = 1;
				if (++logo.x >= SCREEN_WIDTH-2*SPRITE_WIDTH)
				{
					Erase_Sprite((sprite_ptr)&logo);
					logo.state = SPRITE_DEAD;
					redraw = 0;
				}
			}
		}
			else
			{
				if (rand()%100 == 0)
				{
					logo.state		=SPRITE_ALIVE;
					logo.y_old 		= logo.y;
					logo.x 			=SPRITE_WIDTH;
					logo.y			=rand()%100;
					logo.curr_frame=0;
					logo.anim_speed=3+rand()%6;
					logo.motion_speed=1+rand()%3;
					logo.anim_clock = 0;
					logo.motion_clock = 0;

					Behind_Sprite((sprite_ptr)&logo);
				}
			}

			if(redraw)
			{
				Erase_Sprite((sprite_ptr)&logo);
				Behind_Sprite((sprite_ptr)&logo);
				Draw_Sprite((sprite_ptr)&logo);
				Wait_For_Vsync();
				Show_Double_Buffer(double_buffer);
				logo.x_old = logo.x;
				logo.y_old = logo.y;
			}

			Delay(10);

	} // end while not key

//		for(index=0; index<=300000; index++,Plot_Pixel(rand()%320,
//				rand()%200,0));
		Fade();
		Set_Mode(TEXT_MODE);


}
